"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Accordion = void 0;
var _react = _interopRequireWildcard(require("react"));
var _Context = require("./Context");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const Accordion = StyledAccordion => /*#__PURE__*/(0, _react.forwardRef)((_ref, ref) => {
  let {
    type = 'single',
    isCollapsible = true,
    isDisabled = false,
    children,
    ...props
  } = _ref;
  const {
    onValueChange
  } = props;
  const [openItems, setOpenItems] = _react.default.useState([]);
  (0, _react.useEffect)(() => {
    if (props.value) {
      if (type === 'single' && typeof props.value === 'string') {
        setOpenItems([props.value]);
      } else if (type === 'multiple' && Array.isArray(props.value)) {
        setOpenItems(props.value.map(item => item));
      }
    } else {
      setOpenItems([]);
    }
    if (!props.value) {
      if (props.defaultValue) {
        if (type === 'single' && typeof props.defaultValue === 'string') {
          setOpenItems([props.defaultValue]);
        } else if (type === 'multiple' && Array.isArray(props.defaultValue)) {
          setOpenItems(props.defaultValue.map(item => item));
        }
      } else {
        setOpenItems([]);
      }
    }
  }, [props.defaultValue, props.value, type, setOpenItems]);
  (0, _react.useEffect)(() => {
    if (onValueChange) {
      onValueChange(openItems);
    }
  }, [openItems, onValueChange]);
  const contextValue = (0, _react.useMemo)(() => {
    return {
      type: type,
      isCollapsible: isCollapsible,
      openItems,
      setOpenItems,
      isDisabledAccordion: isDisabled
    };
  }, [type, isCollapsible, openItems, setOpenItems, isDisabled]);
  return /*#__PURE__*/_react.default.createElement(_Context.AccordionContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/_react.default.createElement(StyledAccordion, _extends({
    ref: ref
  }, props, {
    states: {
      disabled: isDisabled
    }
  }), children));
});
exports.Accordion = Accordion;
//# sourceMappingURL=Accordion.js.map