function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { forwardRef, useEffect, useMemo } from 'react';
import { AccordionContext } from './Context';
export const Accordion = StyledAccordion => /*#__PURE__*/forwardRef((_ref, ref) => {
  let {
    type = 'single',
    isCollapsible = true,
    isDisabled = false,
    children,
    ...props
  } = _ref;
  const {
    onValueChange
  } = props;
  const [openItems, setOpenItems] = React.useState([]);
  useEffect(() => {
    if (props.value) {
      if (type === 'single' && typeof props.value === 'string') {
        setOpenItems([props.value]);
      } else if (type === 'multiple' && Array.isArray(props.value)) {
        setOpenItems(props.value.map(item => item));
      }
    } else {
      setOpenItems([]);
    }
    if (!props.value) {
      if (props.defaultValue) {
        if (type === 'single' && typeof props.defaultValue === 'string') {
          setOpenItems([props.defaultValue]);
        } else if (type === 'multiple' && Array.isArray(props.defaultValue)) {
          setOpenItems(props.defaultValue.map(item => item));
        }
      } else {
        setOpenItems([]);
      }
    }
  }, [props.defaultValue, props.value, type, setOpenItems]);
  useEffect(() => {
    if (onValueChange) {
      onValueChange(openItems);
    }
  }, [openItems, onValueChange]);
  const contextValue = useMemo(() => {
    return {
      type: type,
      isCollapsible: isCollapsible,
      openItems,
      setOpenItems,
      isDisabledAccordion: isDisabled
    };
  }, [type, isCollapsible, openItems, setOpenItems, isDisabled]);
  return /*#__PURE__*/React.createElement(AccordionContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/React.createElement(StyledAccordion, _extends({
    ref: ref
  }, props, {
    states: {
      disabled: isDisabled
    }
  }), children));
});
//# sourceMappingURL=Accordion.js.map